## cantor 25.12.1+p24.04+vunstable+git20260205.0459

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.13 FATAL_ERROR)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set (RELEASE_SERVICE_VERSION_MAJOR "26")
set (RELEASE_SERVICE_VERSION_MINOR "03")
set (RELEASE_SERVICE_VERSION_MICRO "70")
set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

project(cantor VERSION ${RELEASE_SERVICE_VERSION})

set(QT_MIN_VERSION "6.5.0")
set(KF_MIN_VERSION "6.3.0")

find_package(ECM ${KF_MIN_VERSION} REQUIRED CONFIG)
set(CMAKE_MODULE_PATH ${cantor_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH} )

include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddAppIcon)
include(KDEClangFormat)
include(GenerateExportHeader)
include(FeatureSummary)

set( SharedMimeInfo_MINIMUM_VERSION "1.3" ) #TODO: What is the minimum required version?
find_package(SharedMimeInfo ${SharedMimeInfo_MINIMUM_VERSION} REQUIRED)

option(BUILD_DOC "Whether to build the documentation" ON)

find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED
    Core
    Widgets
    PrintSupport
    Svg
    Xml
    Test
)

find_package(KF6 ${KF_MIN_VERSION} REQUIRED
    Config
    Crash
    Completion
    NewStuffCore
    NewStuff
    IconThemes
    TextEditor
    CoreAddons
    Archive
    Parts
    SyntaxHighlighting
    TextWidgets
    KIO
    XmlGui
    I18n
)

find_package(LibXml2 REQUIRED)
find_package(LibXslt REQUIRED)

option(ENABLE_EMBEDDED_DOCUMENTATION "Enable the emedded documentation depending on QtHelp and QtWebEngine" ON)
if (ENABLE_EMBEDDED_DOCUMENTATION)
    find_package(Qt6 ${QT_MIN_VERSION} CONFIG REQUIRED
        Help
        WebEngineCore
        WebEngineWidgets
    )
    add_definitions (-DHAVE_EMBEDDED_DOCUMENTATION)
endif ()

if (BUILD_DOC)
    find_package(KF6DocTools ${KF_MIN_VERSION})
    set_package_properties(KF6DocTools PROPERTIES
        DESCRIPTION "Tools to generate documentation"
        TYPE REQUIRED
    )
endif ()

find_package(Poppler "22.02.0" COMPONENTS Qt6)

option(USE_LIBSPECTRE "Use libspectre library" ON)

add_subdirectory(thirdparty)
# Need to set this here, because variable can't move from subdirectory (thirdparty) to upper cmake scope
set(Discount_FOUND TRUE)

if(NOT WIN32 AND USE_LIBSPECTRE)
    set_package_properties(LibSpectre PROPERTIES DESCRIPTION "A PostScript rendering library"
        URL "https://www.freedesktop.org/wiki/Software/libspectre/"
        TYPE OPTIONAL
        PURPOSE "Support for rendering EPS files in Cantor")

    find_package(LibSpectre)
    if(LIBSPECTRE_FOUND)
        set(WITH_EPS On)
    else(LIBSPECTRE_FOUND)
        set(WITH_EPS Off)
    endif(LIBSPECTRE_FOUND)

else()
    set(WITH_EPS Off)
endif()

#[[
find_package(Discount 2.2.0)
set_package_properties(Discount PROPERTIES DESCRIPTION "A C implementation of the Markdown markup language"
    URL "https://www.pell.portland.or.us/~orc/Code/discount/"
    TYPE OPTIONAL
    PURPOSE "Used for Markdown entries in Cantor")
]]#

add_definitions(
    -DQT_NO_CAST_TO_ASCII
    -DQT_NO_CAST_FROM_ASCII
    -DQT_NO_URL_CAST_FROM_STRING
    -DQT_NO_CAST_FROM_BYTEARRAY
    -DQT_USE_QSTRINGBUILDER
    -DQT_NO_NARROWING_CONVERSIONS_IN_CONNECT
    -DQT_NO_SIGNALS_SLOTS_KEYWORDS
    -DQT_DEPRECATED_WARNINGS_SINCE=0x060000
    -DKF_DEPRECATED_WARNINGS_SINCE=0x060000
)
if (NOT WIN32)
    # Strict iterators can't be used on Windows, they lead to a link error
    # when application code iterates over a QVector<QPoint> for instance, unless
    # Qt itself was also built with strict iterators.
    # See example at https://bugreports.qt.io/browse/AUTOSUITE-946
    add_definitions(-DQT_STRICT_ITERATORS)
endif()

if (CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pedantic")

   # both gcc & clang support it since the same version
   if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 5.0.0)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wzero-as-null-pointer-constant" )
   endif()
endif()

set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -DQT_NO_DEBUG_OUTPUT")

kde_enable_exceptions()

# FIXME Looks like docbook on Windows isn't buildable at all, so it is temporarily disabled
if(NOT WIN32 AND BUILD_DOC)
    add_subdirectory(doc)
endif()
add_subdirectory(src)
add_subdirectory(icons)

set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/Cantor")
configure_package_config_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/CantorConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/CantorConfig.cmake
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}/
    #PATH_VARS INCLUDE_INSTALL_DIR SYSCONFIG_INSTALL_DIR
)

ecm_setup_version(${RELEASE_SERVICE_VERSION}
    VARIABLE_PREFIX CANTOR
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/cantor_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/CantorConfigVersion.cmake"
)
install(
    FILES ${CMAKE_CURRENT_BINARY_DIR}/CantorConfig.cmake
          ${CMAKE_CURRENT_BINARY_DIR}/CantorConfigVersion.cmake
    DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    COMPONENT Devel
)

install(EXPORT CantorTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE CantorTargets.cmake
    NAMESPACE Cantor::
)


ki18n_install(po)
if (BUILD_DOC)
    kdoctools_install(po)
endif ()
install(FILES org.kde.cantor.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})

file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h *.c)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== src/CMakeLists.txt ===
#########################################################################
# Subdirectories
#########################################################################
add_subdirectory(lib)
add_subdirectory(scripteditor)

include_directories( lib ${CMAKE_CURRENT_BINARY_DIR}/lib)
if(BUILD_TESTING)
  include(ECMMarkAsTest)
  include_directories( lib/test )
endif(BUILD_TESTING)

add_subdirectory(backends)
add_subdirectory(assistants)
add_subdirectory(xslt)
add_subdirectory(panelplugins)


#build the config object in a separate library, shared between shell and part
kconfig_add_kcfg_files(config_SRCS settings.kcfgc)
add_library( cantor_config SHARED ${config_SRCS} )
target_link_libraries( cantor_config KF6::ConfigGui Qt6::Widgets )
generate_export_header( cantor_config BASE_NAME cantor_config )
install( TARGETS cantor_config ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

set(cantor_SRCS
   main.cpp
   cantor.cpp
   backendchoosedialog.cpp

   cantor.qrc
)

install(FILES cantor.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(cantor_SRCS settings.ui)
ki18n_wrap_ui(cantor_SRCS formating.ui)
ki18n_wrap_ui(cantor_SRCS backendchooser.ui)

file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/../icons/*-apps-cantor.png")
ecm_add_app_icon(cantor_SRCS ICONS ${ICONS_SRCS})
add_executable(cantor ${cantor_SRCS})

target_link_libraries(cantor KF6::Parts KF6::NewStuffWidgets KF6::ConfigCore KF6::CoreAddons KF6::ConfigGui
    KF6::Crash KF6::XmlGui KF6::TextEditor cantorlibs cantor_config)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor Qt6::WebEngineCore)
endif()

########### install files ###############
install( TARGETS cantor ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )
install( FILES org.kde.cantor.desktop  DESTINATION ${KDE_INSTALL_APPDIR} )
install( FILES cantor.knsrc cantor-documentation.knsrc DESTINATION ${KDE_INSTALL_KNSRCDIR} )
install( FILES cantor.xml DESTINATION ${KDE_INSTALL_MIMEDIR} )
update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})

#########################################################################
# KPART SECTION
#########################################################################

set(cantor_PART_SRCS
   cantor_part.cpp
   cantorcompletionmodel.cpp
   worksheet.cpp
   worksheetview.cpp
   worksheetentry.cpp
   worksheettexteditoritem.cpp
   worksheettextitem.cpp
   worksheetimageitem.cpp
   commandentry.cpp
   textentry.cpp
   markdownentry.cpp
   pagebreakentry.cpp
   imageentry.cpp
   latexentry.cpp
   placeholderentry.cpp
   horizontalruleentry.cpp
   hierarchyentry.cpp
   worksheetcursor.cpp
   searchbar.cpp
   actionbar.cpp
   worksheettoolbutton.cpp
   imagesettingsdialog.cpp
   scripteditor/scripteditorwidget.cpp
   resultitem.cpp
   textresultitem.cpp
   imageresultitem.cpp
   animationresultitem.cpp
   loadedexpression.cpp
   animation.cpp
   mathrender.cpp
   mathrendertask.cpp
   worksheetcontrolitem.cpp
   dynamichighlighter.cpp

   cantor_part.qrc
 )

ki18n_wrap_ui(cantor_PART_SRCS imagesettings.ui)
ki18n_wrap_ui(cantor_PART_SRCS standardsearchbar.ui)
ki18n_wrap_ui(cantor_PART_SRCS extendedsearchbar.ui)

set(PATH_TO_CANTOR_BACKENDS "${KDE_INSTALL_FULL_PLUGINDIR}")

configure_file (config-cantor.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-cantor.h )

kcoreaddons_add_plugin(cantorpart
    SOURCES ${cantor_PART_SRCS}
    INSTALL_NAMESPACE "kf6/parts")

add_dependencies(cantorpart discount_project)
target_include_directories(cantorpart PRIVATE ${CMAKE_BINARY_DIR}/thirdparty/src/discount_project)
target_link_libraries(cantorpart KF6::Parts KF6::NewStuffWidgets KF6::TextEditor KF6::TextWidgets
                     KF6::KIOCore KF6::KIOFileWidgets KF6::KIOWidgets Discount::Lib
                     Qt6::PrintSupport cantorlibs cantor_config LibXslt::LibXslt LibXml2::LibXml2)

if(BUILD_TESTING)
    add_subdirectory(test)
endif(BUILD_TESTING)

=== src/lib/CMakeLists.txt ===
if(LIBSPECTRE_FOUND)
   include_directories(${LIBSPECTRE_INCLUDE_DIR})
endif(LIBSPECTRE_FOUND)

set( cantor_LIB_SRCS
  session.cpp
  expression.cpp
  backend.cpp
  result.cpp
  textresult.cpp
  imageresult.cpp
  mimeresult.cpp
  epsresult.cpp
  latexresult.cpp
  latexrenderer.cpp
  renderer.cpp
  helpresult.cpp
  animationresult.cpp
  htmlresult.cpp
  extension.cpp
  assistant.cpp
  syntaxhelpobject.cpp
  defaultvariablemodel.cpp
  panelplugin.cpp
  panelpluginhandler.cpp
  worksheetaccess.cpp
  directives/plotdirectives.cpp
  jupyterutils.cpp
  graphicpackage.cpp
  keywordsmanager.cpp
)

Set( cantor_LIB_HDRS
  cantor_macros.h
  #base classes
  backend.h
  session.h
  expression.h
  extension.h
  syntaxhelpobject.h
  #results
  animationresult.h
  epsresult.h
  helpresult.h
  imageresult.h
  latexresult.h
  renderer.h
  result.h
  textresult.h
  mimeresult.h
  htmlresult.h
  #helper classes
  defaultvariablemodel.h
  worksheetaccess.h
  jupyterutils.h
  graphicpackage.h
  # plugin classes
  panelplugin.h
  panelpluginhandler.h
  keywordsmanager.h
)

ki18n_wrap_ui(cantor_LIB_SRCS directives/axisrange.ui directives/plottitle.ui)

kconfig_add_kcfg_files(cantor_LIB_SRCS cantor_libs_settings.kcfgc)
install(FILES cantor_libs.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

configure_file (config-cantorlib.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-cantorlib.h )

add_library( cantorlibs  SHARED ${cantor_LIB_SRCS} )
generate_export_header(cantorlibs BASE_NAME cantor)

target_link_libraries( cantorlibs
  KF6::Completion
  KF6::IconThemes
  KF6::KIOCore
  KF6::KIOFileWidgets
  KF6::KIOWidgets
  KF6::Archive
  KF6::ConfigCore
  KF6::ConfigGui
  KF6::I18n
  KF6::SyntaxHighlighting
  KF6::XmlGui
  Qt6::Xml
  Qt6::Svg
  Poppler::Qt6
)

if(LIBSPECTRE_FOUND)
    target_link_libraries(cantorlibs ${LIBSPECTRE_LIBRARY})
endif(LIBSPECTRE_FOUND)

set (CANTORLIBS_SOVERSION 28)
set_target_properties( cantorlibs PROPERTIES VERSION ${RELEASE_SERVICE_VERSION} SOVERSION ${CANTORLIBS_SOVERSION})

ecm_setup_version(${RELEASE_SERVICE_VERSION}
    VARIABLE_PREFIX CANTOR
    SOVERSION ${CANTORLIBS_SOVERSION}
    VERSION_HEADER ${CMAKE_CURRENT_BINARY_DIR}/cantorlibs_version.h
)

install( TARGETS cantorlibs EXPORT CantorTargets  ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(
  FILES
    ${cantor_LIB_HDRS}
    ${CMAKE_CURRENT_BINARY_DIR}/cantor_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/cantorlibs_version.h
  DESTINATION ${KDE_INSTALL_INCLUDEDIR}/cantor
  COMPONENT Devel
)

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== src/test/CMakeLists.txt ===
set(worksheettest_SRCS
    ../worksheet.cpp
    ../worksheetview.cpp
    ../worksheetentry.cpp
    ../worksheettexteditoritem.cpp
    ../worksheettextitem.cpp
    ../worksheetimageitem.cpp
    ../cantorcompletionmodel.cpp
    ../commandentry.cpp
    ../textentry.cpp
    ../markdownentry.cpp
    ../pagebreakentry.cpp
    ../imageentry.cpp
    ../latexentry.cpp
    ../placeholderentry.cpp
    ../horizontalruleentry.cpp
    ../hierarchyentry.cpp
    ../worksheetcursor.cpp
    ../searchbar.cpp
    ../actionbar.cpp
    ../worksheettoolbutton.cpp
    ../imagesettingsdialog.cpp
    ../scripteditor/scripteditorwidget.cpp
    ../resultitem.cpp
    ../textresultitem.cpp
    ../imageresultitem.cpp
    ../animationresultitem.cpp
    ../loadedexpression.cpp
    ../animation.cpp
    ../mathrender.cpp
    ../mathrendertask.cpp
    ../worksheetcontrolitem.cpp
    ../dynamichighlighter.cpp
    worksheet_test.cpp)

ki18n_wrap_ui(worksheettest_SRCS ../imagesettings.ui)
ki18n_wrap_ui(worksheettest_SRCS ../standardsearchbar.ui)
ki18n_wrap_ui(worksheettest_SRCS ../extendedsearchbar.ui)

file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/data)
configure_file("data/Lecture-2B-Single-Atom-Lasing.ipynb" data COPYONLY)
configure_file("data/AEC.04 - Evolutionary Strategies and Covariance Matrix Adaptation.ipynb" data COPYONLY)
configure_file("data/Population_Genetics.ipynb" data COPYONLY)
configure_file("data/A Reaction-Diffusion Equation Solver in Python with Numpy.ipynb" data COPYONLY)
configure_file("data/Automata and Computability using Jupyter.ipynb" data COPYONLY)
configure_file("data/Cue Combination with Neural Populations .ipynb" data COPYONLY)
configure_file("data/Transformation2D.ipynb" data COPYONLY)
configure_file("data/TestMarkdownAttachment.ipynb" data COPYONLY)
configure_file("data/TestEntryLoad1.ipynb" data COPYONLY)
configure_file("data/TestEntryLoad2.ipynb" data COPYONLY)
configure_file("data/TestResultsLoad.ipynb" data COPYONLY)
configure_file("data/TestNotebookWithJson.ipynb" data COPYONLY)
configure_file("data/TestNotebookWithModJson.ipynb" data COPYONLY)
configure_file("data/EmptyPythonWorksheet.cws" data COPYONLY)
configure_file("data/TestCommandEntryExecutionAction.cws" data COPYONLY)
configure_file("data/TwoCommandEntryWithResults.cws" data COPYONLY)

set(PATH_TO_TEST_NOTEBOOKS ${CMAKE_CURRENT_BINARY_DIR}/data)
configure_file (config-cantor-test.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-cantor-test.h )

add_executable( testworksheet ${worksheettest_SRCS})
#add_test(NAME testworksheet COMMAND testworksheet)
target_link_libraries( testworksheet
    cantorlibs
    cantor_config
    Qt6::Test
    Qt6::PrintSupport
    Qt6::Xml
    KF6::TextEditor
    Poppler::Qt6
    LibXslt::LibXslt
    LibXml2::LibXml2
)

if(LIBSPECTRE_FOUND)
    target_link_libraries(testworksheet ${LIBSPECTRE_LIBRARY})
endif(LIBSPECTRE_FOUND)
if(Discount_FOUND)
    target_link_libraries(testworksheet Discount::Lib)
endif(Discount_FOUND)

=== src/backends/R/CMakeLists.txt ===
include_directories(${R_INCLUDEDIR})
LINK_DIRECTORIES(${R_SHAREDLIBDIR})

if(NOT WIN32)
# rserver is using RInterface.h which is Unix only
# see https://colinfay.me/writing-r-extensions/linking-guis-and-other-front-ends-to-r.html
add_subdirectory(rserver)
endif()

set( RBackend_SRCS
  rbackend.cpp
  rsession.cpp
  rexpression.cpp
  rextensions.cpp
  rsettingswidget.cpp
  rvariablemodel.cpp
  ../backendsettingswidget.cpp
)

kconfig_add_kcfg_files(RBackend_SRCS rserver/settings.kcfgc)

set(network_xml rserver/org.kde.Cantor.R.xml)
find_package(Qt6 REQUIRED COMPONENTS DBus)
qt_add_dbus_interface(RBackend_SRCS ${network_xml} rserver_interface )

ki18n_wrap_ui(RBackend_SRCS settings.ui)

add_backend(rbackend ${RBackend_SRCS})

set_target_properties( cantor_rbackend PROPERTIES INSTALL_RPATH_USE_LINK_PATH false)

target_link_libraries( cantor_rbackend ${R_USED_LIBS} Qt6::DBus KF6::SyntaxHighlighting)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_rbackend cantor_help)
endif ()

if(MSVC)
# When compiling with MSVC, we have to create a .lib file for R.dll, first
find_package(Python3 COMPONENTS Interpreter REQUIRED)
add_custom_target(R_lib COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/GenLibFile.py ${R_R_LIBRARY} ${CMAKE_BINARY_DIR} ${CMAKE_SYSTEM_PROCESSOR}
                        COMMENT "Generate .lib file for R.dll")
add_dependencies(cantor_rbackend R_lib)
endif(MSVC)

if(BUILD_TESTING)
  add_executable( testr testr.cpp)
  add_test(NAME testr COMMAND testr)
  ecm_mark_as_test(testr)
  target_link_libraries( testr
    Qt6::Test
    cantorlibs
    cantortest
  )
endif(BUILD_TESTING)

install( FILES cantor_r.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

=== src/backends/julia/CMakeLists.txt ===
include_directories(${JULIA_INCLUDE_DIRS})

find_package(Qt6 REQUIRED COMPONENTS DBus)
add_subdirectory(juliaserver)

set(JuliaBackend_SRCS
  juliabackend.cpp
  juliasession.cpp
  juliaexpression.cpp
  juliavariablemodel.cpp
  juliaextensions.cpp
  juliasettingswidget.cpp
  ../backendsettingswidget.cpp
)

kconfig_add_kcfg_files(JuliaBackend_SRCS settings.kcfgc)
ki18n_wrap_ui(JuliaBackend_SRCS settings.ui)

add_backend(juliabackend ${JuliaBackend_SRCS})

target_link_libraries(cantor_juliabackend
  ${JULIA_LIBRARY}
  Qt6::DBus
  KF6::SyntaxHighlighting
)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_juliabackend cantor_help)
endif ()

if(BUILD_TESTING)
  add_executable(testjulia testjulia.cpp settings.cpp)
  add_test(NAME testjulia COMMAND testjulia)
  target_link_libraries(testjulia
    Qt6::Test
    cantorlibs
    cantortest
  )
endif(BUILD_TESTING)

install(FILES juliabackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
file(GLOB scripts "${CMAKE_CURRENT_SOURCE_DIR}/scripts/*.jl")
install(
  FILES ${scripts}
  DESTINATION ${KDE_INSTALL_DATADIR}/cantor/juliabackend/scripts
)

install(FILES graphic_packages.xml DESTINATION ${KDE_INSTALL_DATADIR}/cantor/julia)

=== src/backends/kalgebra/CMakeLists.txt ===
set( KAlgebraBackend_SRCS
  kalgebrasyntaxhelpobject.cpp
  kalgebrabackend.cpp
  kalgebrasession.cpp
  kalgebraexpression.cpp
  kalgebraextensions.cpp
  kalgebravariablemodel.cpp
)

remove_definitions(-DQT_NO_CAST_TO_ASCII)
remove_definitions(-DQT_NO_CAST_FROM_ASCII)

kconfig_add_kcfg_files(KAlgebraBackend_SRCS settings.kcfgc)
install(FILES kalgebrabackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(KAlgebraBackend_SRCS settings.ui)

add_backend(kalgebrabackend ${KAlgebraBackend_SRCS})

target_link_libraries( cantor_kalgebrabackend KF6::Analitza KF6::AnalitzaGui )

install( FILES cantor_kalgebra.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

=== src/backends/lua/CMakeLists.txt ===
set(LuaBackend_SRCS
  luabackend.cpp
  luasession.cpp
  luaexpression.cpp
  luaextensions.cpp
  luasettingswidget.cpp
  luavariablemodel.cpp
  ../backendsettingswidget.cpp
)

kconfig_add_kcfg_files(LuaBackend_SRCS settings.kcfgc)
install(FILES luabackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(LuaBackend_SRCS settings.ui)

add_backend(luabackend ${LuaBackend_SRCS})

include_directories(${LUAJIT_INCLUDE_DIR})

target_link_libraries(cantor_luabackend ${LUAJIT_LIBRARY} KF6::SyntaxHighlighting)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_luabackend cantor_help)
endif ()

if(BUILD_TESTING)
  add_executable( testlua testlua.cpp)
  add_test(NAME testlua COMMAND testlua)
  ecm_mark_as_test(testlua)
  target_link_libraries( testlua
    Qt6::Test
    cantorlibs
    cantortest
  )
endif(BUILD_TESTING)

install(FILES cantor_lua.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

=== src/backends/maxima/CMakeLists.txt ===
set( MaximaBackend_SRCS
  maximabackend.cpp
  maximasession.cpp
  maximaexpression.cpp
  maximaextensions.cpp
  maximasettingswidget.cpp
  maximavariablemodel.cpp
  maximasyntaxhelpobject.cpp
  ../backendsettingswidget.cpp
)

kconfig_add_kcfg_files(MaximaBackend_SRCS settings.kcfgc)
install(FILES maximabackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(MaximaBackend_SRCS settings.ui)

add_backend(maximabackend ${MaximaBackend_SRCS})

target_link_libraries(cantor_maximabackend KF6::SyntaxHighlighting)
if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_maximabackend cantor_help)
endif ()

target_link_libraries(cantor_maximabackend KF6::SyntaxHighlighting)

if(BUILD_TESTING)
  add_executable( testmaxima testmaxima.cpp)
  add_test(NAME testmaxima COMMAND testmaxima)
  target_link_libraries( testmaxima
    Qt6::Test
    cantorlibs
    cantortest
  )
endif()

install( FILES cantor_maxima.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )
install( FILES cantor-initmaxima.lisp DESTINATION ${KDE_INSTALL_DATADIR}/cantor/maximabackend)

=== src/backends/octave/CMakeLists.txt ===
set( OctaveBackend_SRCS
  octavebackend.cpp
  octavesession.cpp
  octaveexpression.cpp
  octaveextensions.cpp
  octavesyntaxhelpobject.cpp
  octavevariablemodel.cpp
  octavesettingswidget.cpp
  ../backendsettingswidget.cpp
)

add_subdirectory(scripts)

set(DEFAULT_PLOT_FORMAT "png")

configure_file(octavebackend.kcfg.in ${CMAKE_CURRENT_BINARY_DIR}/octavebackend.kcfg)

kconfig_add_kcfg_files(OctaveBackend_SRCS settings.kcfgc)
install(FILES octavebackend.kcfg.in DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(OctaveBackend_SRCS settings.ui)

add_backend(octavebackend ${OctaveBackend_SRCS})


target_link_libraries(cantor_octavebackend
  KF6::KIOCore
  KF6::ConfigCore
  KF6::ConfigGui
  KF6::SyntaxHighlighting

)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_octavebackend cantor_help)
endif ()

if(BUILD_TESTING)
  add_executable(testoctave testoctave.cpp ${OctaveBackend_SRCS})
  add_test(NAME testoctave COMMAND testoctave)
  target_link_libraries( testoctave
    Qt6::Test
    KF6::SyntaxHighlighting
    cantorlibs
    cantortest
  )
  if (ENABLE_EMBEDDED_DOCUMENTATION)
      target_link_libraries(testoctave cantor_help)
  endif ()
endif()


install(FILES cantor_octave.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

install(FILES graphic_packages.xml DESTINATION ${KDE_INSTALL_DATADIR}/cantor/octave)

=== src/backends/python/CMakeLists.txt ===
set( PythonBackend_SRCS
  pythonbackend.cpp
  pythonsession.cpp
  pythonexpression.cpp
  pythonvariablemodel.cpp
  pythonextensions.cpp
  pythonsettingswidget.cpp
  ../backendsettingswidget.cpp
)

set(PythonServer_SRCS
  pythonservermain.cpp
  pythonserver.cpp
)

qt_add_resources(PythonBackend_RSCS python.qrc)
ki18n_wrap_ui(PythonBackend_SRCS settings.ui)
kconfig_add_kcfg_files(PythonBackend_SRCS settings.kcfgc)

add_backend(pythonbackend ${PythonBackend_SRCS} ${PythonBackend_RSCS})
target_link_libraries(cantor_pythonbackend
  cantorlibs
  KF6::KIOCore
  KF6::ConfigCore
  KF6::ConfigGui
  KF6::SyntaxHighlighting
)

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_pythonbackend cantor_help)
endif ()

add_executable(cantor_pythonserver ${PythonServer_SRCS})
set_target_properties(cantor_pythonserver PROPERTIES INSTALL_RPATH_USE_LINK_PATH false)
if(MSVC)
  set_property(TARGET cantor_pythonserver PROPERTY LINK_FLAGS "/SUBSYSTEM:CONSOLE")
endif()
target_link_libraries(cantor_pythonserver Python3::Python)

if(BUILD_TESTING)
  add_executable(testpython testpython.cpp settings.cpp)
  add_test(NAME testpython COMMAND testpython)
  target_link_libraries(testpython
    Qt6::Test
    KF6::ConfigCore
    KF6::ConfigGui
    cantorlibs
    cantortest
  )
endif(BUILD_TESTING)

install(FILES cantor_python.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR})
install(FILES pythonbackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

install(TARGETS cantor_pythonbackend DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
install(TARGETS cantor_pythonserver DESTINATION ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

install(FILES graphic_packages.xml DESTINATION ${KDE_INSTALL_DATADIR}/cantor/python)

#install(DIRECTORY . DESTINATION ${KDE_INSTALL_DATADIR}/cantor/pythonbackend FILES_MATCHING PATTERN "*.py")

=== src/backends/qalculate/CMakeLists.txt ===
add_subdirectory(plotassistant)
project(cantor-qalculate-backend)

add_definitions(${QALCULATE_CFLAGS})

set( QalculateBackend_SRCS
  qalculatesyntaxhelpobject.cpp
  qalculatebackend.cpp
  qalculatesession.cpp
  qalculateexpression.cpp
  qalculateextensions.cpp
  qalculateextensions.cpp
  qalculatesettingswidget.cpp
  qalculatevariablemodel.cpp
  ../backendsettingswidget.cpp
)

kconfig_add_kcfg_files(QalculateBackend_SRCS settings.kcfgc)
install(FILES qalculatebackend.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})

ki18n_wrap_ui(QalculateBackend_SRCS settings.ui)

add_backend(qalculatebackend ${QalculateBackend_SRCS})

target_link_libraries( cantor_qalculatebackend cantorlibs ${QALCULATE_LIBRARIES})

if (ENABLE_EMBEDDED_DOCUMENTATION)
    target_link_libraries(cantor_qalculatebackend cantor_help)
endif ()

install( FILES cantor_qalculate.knsrc  DESTINATION  ${KDE_INSTALL_KNSRCDIR} )

=== debian/changelog ===
cantor (4:25.12.1+p24.04+vunstable+git20260205.0459-0) noble; urgency=medium

  * Automatic Ubuntu CI Build

 -- Neon CI <neon@kde.org>  Thu, 05 Feb 2026 04:59:55 +0000

## cantor 25.12.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,9 +3,9 @@
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
-set (RELEASE_SERVICE_VERSION_MAJOR "26")
-set (RELEASE_SERVICE_VERSION_MINOR "03")
-set (RELEASE_SERVICE_VERSION_MICRO "70")
+set (RELEASE_SERVICE_VERSION_MAJOR "25")
+set (RELEASE_SERVICE_VERSION_MINOR "12")
+set (RELEASE_SERVICE_VERSION_MICRO "2")
 set (RELEASE_SERVICE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
 
 project(cantor VERSION ${RELEASE_SERVICE_VERSION})

=== debian/changelog ===
cantor (4:25.12.2-0ubuntu1) resolute; urgency=medium

  * New upstream release (25.12.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Feb 2026 12:17:08 +0000

=== debian/control ===
Source: cantor
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Pino Toscano <pino@debian.org>,
Build-Depends: appstream,
               cmake (>= 3.13~),
               debhelper-compat (= 13),
               dh-apparmor,
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               extra-cmake-modules (>= 6.3.0~),
               gettext,
               libanalitza-dev (>= 4:25.12.2~),
               libcups2-dev,
               libkf6archive-dev (>= 6.3.0~),
               libkf6completion-dev (>= 6.3.0~),
               libkf6config-dev (>= 6.3.0~),
               libkf6coreaddons-dev (>= 6.3.0~),
               libkf6crash-dev (>= 6.3.0~),
               libkf6doctools-dev (>= 6.3.0~),
               libkf6i18n-dev (>= 6.3.0~),
               libkf6iconthemes-dev (>= 6.3.0~),
               libkf6kio-dev (>= 6.3.0~),
               libkf6newstuff-dev (>= 6.3.0~),
               libkf6parts-dev (>= 6.3.0~),
               libkf6syntaxhighlighting-dev (>= 6.3.0~),
               libkf6texteditor-dev (>= 6.3.0~),
               libkf6textwidgets-dev (>= 6.3.0~),
               libkf6xmlgui-dev (>= 6.3.0~),
               libluajit-5.1-dev [amd64 arm64 armel armhf i386 mips64el riscv64 s390x],
               libpoppler-qt6-dev (>= 22.02.0~) [!i386],
               libpython3-dev,
               libqalculate-dev,
               libspectre-dev,
               libxml2-dev,
               libxslt1-dev,
               qt6-5compat-dev (>= 6.5.0~),
               qt6-base-dev (>= 6.5.0~),
               qt6-svg-dev (>= 6.5.0~),
               qt6-tools-dev (>= 6.5.0~),
               qt6-webengine-dev (>= 6.5.0~) [amd64 arm64 armhf i386],
               r-base-core,
               shared-mime-info (>= 1.3~),
Standards-Version: 4.7.2
Rules-Requires-Root: no
Homepage: https://cantor.kde.org/
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/cantor
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/cantor

Package: cantor
Architecture: any
Section: math
Depends: ${misc:Depends}, ${shlibs:Depends},
Recommends: cantor-backend-qalculate,
            texlive-plain-generic,
Suggests: cantor-backend-kalgebra,
          cantor-backend-lua [amd64 arm64 armel armhf i386 mips64el riscv64 s390x],
          cantor-backend-maxima,
          cantor-backend-octave,
          cantor-backend-python3,
          cantor-backend-r,
          cantor-backend-sage,
          cantor-backend-scilab [amd64 arm64 ppc64el s390x],
          apparmor
Description: interface for mathematical applications
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 Cantor supports various mathematical applications as backends (provided in
 external packages):
  * Maxima Computer Algebra System (cantor-backend-maxima)
  * R Project for Statistical Computing (cantor-backend-r)
  * Sage Mathematics Software (cantor-backend-sage)
  * Octave (cantor-backend-octave)
  * Python (cantor-backend-python3)
  * Scilab (cantor-backend-scilab)
  * Qalculate! (cantor-backend-qalculate)
  * Lua (cantor-backend-lua)
 .
 This package is part of the KDE education module.

Package: libcantorlibs28abi2
X-Debian-ABI: 2
X-CMake-Target: cantorlibs
Architecture: any
Multi-Arch: same
Section: libs
Depends: libcantorlibs-data (>= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Description: interface for mathematical applications - shared library
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the shared library for Cantor.
 .
 This package is part of the KDE education module.

Package: libcantorlibs-data
Architecture: all
Multi-Arch: foreign
Section: libs
Depends: ${misc:Depends},
Replaces: libcantorlibs28 (<< 4:22.04.1-1~),
Breaks: libcantorlibs28 (<< 4:22.04.1-1~),
Description: interface for mathematical applications - data for shared library
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the data for the shared library for Cantor.
 .
 This package is part of the KDE education module.

Package: libcantor-dev
Architecture: any
Section: libdevel
Depends: libcantorlibs28abi2 (=  ${binary:Version}),
         ${misc:Depends},
Description: interface for mathematical applications - development files
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the development headers for Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-kalgebra
Architecture: any
Section: math
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: KAlgebra backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using KAlgebra
 (https://edu.kde.org/kalgebra) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-lua
Architecture: amd64 amd64v3 i386
Section: math
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Lua backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Lua language
 (https://www.lua.org) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-maxima
Architecture: any
Section: math
Depends: maxima, ${misc:Depends}, ${shlibs:Depends},
Description: Maxima backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Maxima Computer Algebra System
 (http://maxima.sourceforge.net) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-octave
Architecture: any
Section: math
Depends: octave, ${misc:Depends}, ${shlibs:Depends},
Description: Octave backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the GNU Octave language for
 numerical computations (https://www.octave.org/) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-python3
Architecture: any
Section: math
Depends: python3, ${misc:Depends}, ${shlibs:Depends},
Breaks: libcantor-pythonbackend (<< 4:20.04.2~),
Replaces: libcantor-pythonbackend (<< 4:20.04.2~),
Description: Python3 backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Python3 language
 (https://www.python.org/) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-qalculate
Architecture: any
Section: math
Depends: qalc,
         ${misc:Depends},
         ${shlibs:Depends},
Description: Qalculate! backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Qalculate! calculator
 (https://qalculate.github.io/) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-r
Architecture: any
Section: math
Depends: r-base-core, ${misc:Depends}, ${shlibs:Depends},
Suggests: r-base-html,
Description: R backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the R Project for Statistical
 Computing (https://www.r-project.org) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-sage
Architecture: any
Section: math
Depends: ${misc:Depends},
         ${shlibs:Depends},
Suggests: sagemath,
Description: Sage backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Sage Mathematics Software
 (https://www.sagemath.org) in Cantor.
 .
 This package is part of the KDE education module.

Package: cantor-backend-scilab
Architecture: amd64 amd64v3 arm64 ppc64el s390x
Section: math
Depends: scilab-cli, ${misc:Depends}, ${shlibs:Depends},
Description: Scilab backend for Cantor
 Cantor is an application to allow you to you use your favorite mathematical
 applications from within an elegant worksheet interface. It provides dialogs
 to assist with common tasks and allows you to share your worksheets
 with others.
 .
 This package provides the backend for using the Scilab scientific software
 package for numerical computations (https://www.scilab.org) in Cantor.
 .
 This package is part of the KDE education module.
